﻿/*-------------------------------------------------------------------------------
 * WebBrowserControlの中身はIE7なので注意！！ 
 *-------------------------------------------------------------------------------*/
/**
 * ローディング画面描画(&& ボタン非活性化)
 * @param {boolean} flag 
 */
function isLoading(flag) {
  if (flag) {
    buttonIsDisabled(flag);
    document.getElementById('loading').style.display = 'block';
  } else {
    buttonIsDisabled(flag);
    document.getElementById('loading').style.display = 'none';
  }
}

/**
 * 全てのボタンを非活性化する
 * @param {boolean} flag 
 */
function buttonIsDisabled(flag) {
  /* IE7ではgetElementsByClassName使えない
  var bts = document.getElementsByClassName('exec-button');
  for(var idx = 0; idx < bts.length; idx++){
      bts[idx].disabled = flg;
  }*/
  var elem = document.getElementsByTagName("*");
  for (var idx = 0; idx < elem.length; idx++) {
    if (elem[idx].className == 'exec-button') {
      elem[idx].disabled = flag;
    }
  }
}

/**
 * チェック 実行
 */
function checkFiles() {
  var extensionTypes = getExtensionTypes();
  if (extensionTypes === "") {
    return;
  }
  var propertNumber = getPropertyNumber();
  if (propertNumber === false) {
    return;
  }
  var patternNumber = getPatternNumber();
  isLoading(true); // C#の同期処理だとisLoading(true)が叩けないので
  window.external.RunProcess(extensionTypes, propertNumber, patternNumber, true);
}

/**
 * リネーム 実行
 */
function executeRename() {
  var extensionTypes = getExtensionTypes();
  if (extensionTypes === "") {
    return;
  }
  var propertyNumber = getPropertyNumber();
  if (propertyNumber === false) {
    return;
  }
  var patternNumber = getPatternNumber();
  isLoading(true); // C#の同期処理だとisLoading(true)が叩けないので
  window.external.RunProcess(extensionTypes, propertyNumber, patternNumber, false);
}


/**
 * 対象拡張子の取得(Javascript <-> C#での引数/戻り値は数値や文字列といった単純な値のみ可能なため改行文字列で渡す)
 */
function getExtensionTypes() {
  var tempTypes = [];
  var extensionTypes = "";
  var elements = document.getElementsByName('target');
  var idx = 0;
  for (idx; idx < elements.length; idx++) {
    if (elements[idx].checked) {
      tempTypes.push(elements[idx].value);
    }
  }
  if (tempTypes.length <= 0) {
    return extensionTypes;
  }
  for (idx = 0; idx < tempTypes.length; idx++) {
    extensionTypes += tempTypes[idx];
    if (idx !== (tempTypes.length - 1)) {
      extensionTypes += "\n";
    }
  }
  return extensionTypes;
}

/**
 * property-numberの取得
 */
function getPropertyNumber() {
  var num = document.getElementById('property-number').value;
  if (isNaN(num)) {
    console.log('isNaN:' + num);
    return false;
  } else if (parseInt(num) < 0) {
    console.log('minus:' + num);
    return false;
  }
  return parseInt(num);
}

/**
 * get pattern-number
 * @param {integer} patternNumber
 */
function getPatternNumber() {
  var patterns = document.getElementsByName('pattern');
  var index = 0;
  var patternNumber = 0;
  for (index; index < patterns.length; index++) {
    if (patterns[index].checked) {
      patternNumber = patterns[index].value;
      break;
    }
  }
  return patternNumber;
}

/**
 * C#からの結果リスト表示
 * @param {string} html
 */
function drawList(html, isDraw) {
  var div = document.getElementById('result-table');
  if (isDraw) {
    div.style.display = 'block';
    div.innerHTML = html;
  } else {
    div.style.display = 'none';
    div.innerHTML = '';
  }
}